package com.example.impl;

@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2021-03-31T01:35:28.499Z")
@javax.ws.rs.Path("")
@org.springframework.stereotype.Service("TransactionsApi")
@io.swagger.annotations.Api(description = "the Transactions API")
public class TransactionsApiImpl implements com.example.TransactionsApi {

	@org.springframework.beans.factory.annotation.Autowired
	private com.example.service.TransactionsApiService delegate;

	private javax.validation.ValidatorFactory validatorFactory = javax.validation.Validation.buildDefaultValidatorFactory();

	public javax.ws.rs.core.Response create(com.example.model.CreateRequest request) {
		final javax.ws.rs.core.Response.ResponseBuilder __response = javax.ws.rs.core.Response.status(200).cacheControl(javax.ws.rs.core.CacheControl.valueOf("no-cache, no-store, must-revalidate, private"));
		try {
			if (request != null) {
				java.util.Set<javax.validation.ConstraintViolation<com.example.model.CreateRequest>> __validations = this.validatorFactory.getValidator().validate(request);
				if (!__validations.isEmpty()) {
					return __response
						.status(javax.ws.rs.core.Response.Status.BAD_REQUEST)
						.type(javax.ws.rs.core.MediaType.TEXT_PLAIN_TYPE)
						.entity(__validations.stream()
							.map(__v -> __v.getPropertyPath() + " " + __v.getMessage())
							.collect(java.util.stream.Collectors.joining("\n")))
						.build();
				}
			} else {
				return __response.status(javax.ws.rs.core.Response.Status.BAD_REQUEST).build();
			}
			
			com.example.model.CreateTransactionResponse __entity = this.delegate.create(request);
			if (__entity != null) {
				java.util.Set<javax.validation.ConstraintViolation<com.example.model.CreateTransactionResponse>> __validations = this.validatorFactory.getValidator().validate(__entity);
				if (!__validations.isEmpty()) {
					throw new javax.ws.rs.InternalServerErrorException("The server produced an invalid response:\n  " + __validations.stream()
						.map(__v -> __v.getPropertyPath() + " " + __v.getMessage())
						.collect(java.util.stream.Collectors.joining("\n  "))
					);
				}
			} else {
				throw new javax.ws.rs.InternalServerErrorException("Response body missing");
			}
			__response.entity(__entity);
			return __response.build();
		} catch (com.example.service.TransactionsApiService.Create400Exception __e) {
			__response.status(400);
			if (__e.getEntity() != null) {
				java.util.Set<javax.validation.ConstraintViolation<com.example.model.BadRequestResponse>> __validations = this.validatorFactory.getValidator().validate(__e.getEntity());
				if (!__validations.isEmpty()) {
					throw new javax.ws.rs.InternalServerErrorException("The server produced an invalid response:\n  " + __validations.stream()
						.map(__v -> __v.getPropertyPath() + " " + __v.getMessage())
						.collect(java.util.stream.Collectors.joining("\n  "))
					);
				}
			} else {
				throw new javax.ws.rs.InternalServerErrorException("Response body missing");
			}
			__response.entity(__e.getEntity());
			return __response.build();
		} catch (com.example.service.TransactionsApiService.Create401Exception __e) {
			__response.status(401);
			if (__e.getEntity() != null) {
				java.util.Set<javax.validation.ConstraintViolation<com.example.model.UnauthenticatedResponse>> __validations = this.validatorFactory.getValidator().validate(__e.getEntity());
				if (!__validations.isEmpty()) {
					throw new javax.ws.rs.InternalServerErrorException("The server produced an invalid response:\n  " + __validations.stream()
						.map(__v -> __v.getPropertyPath() + " " + __v.getMessage())
						.collect(java.util.stream.Collectors.joining("\n  "))
					);
				}
			} else {
				throw new javax.ws.rs.InternalServerErrorException("Response body missing");
			}
			__response.entity(__e.getEntity());
			return __response.build();
		} catch (com.example.service.TransactionsApiService.Create500Exception __e) {
			__response.status(500);
			if (__e.getEntity() != null) {
				java.util.Set<javax.validation.ConstraintViolation<com.example.model.InternalServerErrorResponse>> __validations = this.validatorFactory.getValidator().validate(__e.getEntity());
				if (!__validations.isEmpty()) {
					throw new javax.ws.rs.InternalServerErrorException("The server produced an invalid response:\n  " + __validations.stream()
						.map(__v -> __v.getPropertyPath() + " " + __v.getMessage())
						.collect(java.util.stream.Collectors.joining("\n  "))
					);
				}
			} else {
				throw new javax.ws.rs.InternalServerErrorException("Response body missing");
			}
			__response.entity(__e.getEntity());
			return __response.build();
		} finally {
		
		}
	}

	public javax.ws.rs.core.Response get(java.lang.String transactionId, java.lang.String format) {
		final javax.ws.rs.core.Response.ResponseBuilder __response = javax.ws.rs.core.Response.status(200).cacheControl(javax.ws.rs.core.CacheControl.valueOf("no-cache, no-store, must-revalidate, private"));
		try {
			com.example.model.Get200Response __entity = this.delegate.get(transactionId, format);
			if (__entity != null) {
				java.util.Set<javax.validation.ConstraintViolation<com.example.model.Get200Response>> __validations = this.validatorFactory.getValidator().validate(__entity);
				if (!__validations.isEmpty()) {
					throw new javax.ws.rs.InternalServerErrorException("The server produced an invalid response:\n  " + __validations.stream()
						.map(__v -> __v.getPropertyPath() + " " + __v.getMessage())
						.collect(java.util.stream.Collectors.joining("\n  "))
					);
				}
			} else {
				throw new javax.ws.rs.InternalServerErrorException("Response body missing");
			}
			__response.entity(__entity);
			return __response.build();
		} catch (com.example.service.TransactionsApiService.Get400Exception __e) {
			__response.status(400);
			if (__e.getEntity() != null) {
				java.util.Set<javax.validation.ConstraintViolation<com.example.model.BadRequestResponse>> __validations = this.validatorFactory.getValidator().validate(__e.getEntity());
				if (!__validations.isEmpty()) {
					throw new javax.ws.rs.InternalServerErrorException("The server produced an invalid response:\n  " + __validations.stream()
						.map(__v -> __v.getPropertyPath() + " " + __v.getMessage())
						.collect(java.util.stream.Collectors.joining("\n  "))
					);
				}
			} else {
				throw new javax.ws.rs.InternalServerErrorException("Response body missing");
			}
			__response.entity(__e.getEntity());
			return __response.build();
		} catch (com.example.service.TransactionsApiService.Get401Exception __e) {
			__response.status(401);
			if (__e.getEntity() != null) {
				java.util.Set<javax.validation.ConstraintViolation<com.example.model.UnauthenticatedResponse>> __validations = this.validatorFactory.getValidator().validate(__e.getEntity());
				if (!__validations.isEmpty()) {
					throw new javax.ws.rs.InternalServerErrorException("The server produced an invalid response:\n  " + __validations.stream()
						.map(__v -> __v.getPropertyPath() + " " + __v.getMessage())
						.collect(java.util.stream.Collectors.joining("\n  "))
					);
				}
			} else {
				throw new javax.ws.rs.InternalServerErrorException("Response body missing");
			}
			__response.entity(__e.getEntity());
			return __response.build();
		} catch (com.example.service.TransactionsApiService.Get404Exception __e) {
			__response.status(404);
			if (__e.getEntity() != null) {
				java.util.Set<javax.validation.ConstraintViolation<com.example.model.UnauthenticatedResponse>> __validations = this.validatorFactory.getValidator().validate(__e.getEntity());
				if (!__validations.isEmpty()) {
					throw new javax.ws.rs.InternalServerErrorException("The server produced an invalid response:\n  " + __validations.stream()
						.map(__v -> __v.getPropertyPath() + " " + __v.getMessage())
						.collect(java.util.stream.Collectors.joining("\n  "))
					);
				}
			} else {
				throw new javax.ws.rs.InternalServerErrorException("Response body missing");
			}
			__response.entity(__e.getEntity());
			return __response.build();
		} catch (com.example.service.TransactionsApiService.Get500Exception __e) {
			__response.status(500);
			if (__e.getEntity() != null) {
				java.util.Set<javax.validation.ConstraintViolation<com.example.model.InternalServerErrorResponse>> __validations = this.validatorFactory.getValidator().validate(__e.getEntity());
				if (!__validations.isEmpty()) {
					throw new javax.ws.rs.InternalServerErrorException("The server produced an invalid response:\n  " + __validations.stream()
						.map(__v -> __v.getPropertyPath() + " " + __v.getMessage())
						.collect(java.util.stream.Collectors.joining("\n  "))
					);
				}
			} else {
				throw new javax.ws.rs.InternalServerErrorException("Response body missing");
			}
			__response.entity(__e.getEntity());
			return __response.build();
		} finally {
		
		}
	}

}
