package com.example;

@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2021-03-31T01:35:28.499Z")
@io.swagger.annotations.Api(description = "the Transactions API")
@javax.ws.rs.Path("")
public interface TransactionsApi {

	@javax.ws.rs.POST
	@javax.ws.rs.Path("/transactions")
	@javax.ws.rs.Consumes({ "application/json" })
	@javax.ws.rs.Produces({ "application/json" })
	@io.swagger.annotations.ApiOperation(value = "Create a transaction", notes = "Triggers an ID verification, either as an SMS we will send to your customers or as a link which you can pass on or redirect your customer to however you like.", response = com.example.model.CreateTransactionResponse.class, authorizations = {
		@io.swagger.annotations.Authorization(value = "oAuth2ClientCredentials", scopes = {
			@io.swagger.annotations.AuthorizationScope(scope = "transactions/post", description = "Craete Transactions")
		})
	}, tags={ "transactions" })
	@io.swagger.annotations.ApiResponses(value = {
		@io.swagger.annotations.ApiResponse(code = 200, message = "OK", response = com.example.model.CreateTransactionResponse.class),
		@io.swagger.annotations.ApiResponse(code = 400, message = "The server could not understand the request due to invalid syntax.", response = com.example.model.BadRequestResponse.class),
		@io.swagger.annotations.ApiResponse(code = 401, message = "Although the HTTP standard specifies \"unauthorized\", semantically this response means \"unauthenticated\". That is, the client must authenticate itself to get the requested response.", response = com.example.model.UnauthenticatedResponse.class),
		@io.swagger.annotations.ApiResponse(code = 500, message = "The server has encountered a situation it doesn't know how to handle.", response = com.example.model.InternalServerErrorResponse.class)
	})
	javax.ws.rs.core.Response create(@io.swagger.annotations.ApiParam(value = "Create Transaction Parameters", required = true) com.example.model.CreateRequest request);

	@javax.ws.rs.GET
	@javax.ws.rs.Path("/transactions/{transaction_id}/{format}")
	@javax.ws.rs.Produces({ "application/json" })
	@io.swagger.annotations.ApiOperation(value = "Fetch a transaction", notes = "Get the transaction payload data by `trasanction_id`. You can generate a PDF (Base64 data) by setting the `format` to \"pdf\".", response = com.example.model.Get200Response.class, authorizations = {
		@io.swagger.annotations.Authorization(value = "oAuth2ClientCredentials", scopes = {
			@io.swagger.annotations.AuthorizationScope(scope = "transactions/get", description = "Get Transactions")
		})
	}, tags={ "transactions" })
	@io.swagger.annotations.ApiResponses(value = {
		@io.swagger.annotations.ApiResponse(code = 200, message = "OK", response = com.example.model.Get200Response.class),
		@io.swagger.annotations.ApiResponse(code = 400, message = "The server could not understand the request due to invalid syntax.", response = com.example.model.BadRequestResponse.class),
		@io.swagger.annotations.ApiResponse(code = 401, message = "Although the HTTP standard specifies \"unauthorized\", semantically this response means \"unauthenticated\". That is, the client must authenticate itself to get the requested response.", response = com.example.model.UnauthenticatedResponse.class),
		@io.swagger.annotations.ApiResponse(code = 404, message = "Although the HTTP standard specifies \"unauthorized\", semantically this response means \"unauthenticated\". That is, the client must authenticate itself to get the requested response.", response = com.example.model.UnauthenticatedResponse.class),
		@io.swagger.annotations.ApiResponse(code = 500, message = "The server has encountered a situation it doesn't know how to handle.", response = com.example.model.InternalServerErrorResponse.class)
	})
	javax.ws.rs.core.Response get(@io.swagger.annotations.ApiParam(value = "Transaction ID", required = true) @javax.ws.rs.PathParam("transaction_id") java.lang.String transaction_id, @io.swagger.annotations.ApiParam(value = "Available values are: json, pdf", required = true) @javax.ws.rs.PathParam("format") java.lang.String format);

}
